
import java.awt.*;
import java.lang.*;
import java.applet.*;
import java.awt.event.*;



public class SlideShow extends Applet implements Runnable,ItemListener {
  MediaTracker LoadImages;
  Image slides[];
  String imagefile, type, caption;   //parameters from the applet tag
  Thread AutoShow;
  int images;
  public int index = 0,direction=1;
  Button forward, backward; 
  Checkbox auto; 
  List delay;
  Label title,delayLabel,slideName; 


public void init() {

  loadSlides();
	


//****************************************************************
       Create the SlideViewer layout. USER INTERFACE  
  ****************************************************************
  setLayout(new BorderLayout());
        
  forward = new Button("Next");
  forward.setBackground( Color.blue );
  forward.setForeground( Color.white ); 
  forward.setFont(new Font("SansSerif", Font.BOLD,12));
  forward.addActionListener(new ForwardButtonHandler(this));

  backward = new Button("Previous");
  backward.setBackground( Color.blue );
  backward.setForeground( Color.white ); 
  backward.setFont(new Font("SansSerif", Font.BOLD,12));
  backward.addActionListener(new BackwardButtonHandler(this));

  auto = new Checkbox("AutoCycle");
  auto.setState(true);   
  auto.addItemListener(this);

  delay=new List(2,false);
  delay.addItem("100");
  delay.addItem("200");
  delay.addItem("300");
  delay.addItem("500");
  delay.addItem("700");
  delay.addItem("1000");
  delay.addItem("1500");
  delay.addItem("2000");
  delay.addItem("3000");
  delay.addItem("5000");
  delay.select(3);
  delay.addItemListener(this);
    
  delayLabel= new Label("Delay");

  title = new Label(caption);
  title.setFont(new Font("Helvetica", Font.BOLD, 10));
  
  slideName = new Label("SLIDE-SHOW");
  
  Panel marquee = new Panel();
  marquee.setLayout(new BorderLayout());
  marquee.setFont(new Font("Helvetica", Font.BOLD, 14));
        
  marquee.add("West", title);        
  marquee.add("East", slideName);     

  Panel control = new Panel();
  Panel options = new Panel();
  control.setLayout(new FlowLayout());
  options.setBackground(new Color(200,200,100));
  
  control.add(backward);
  control.add(forward);
 
  options.add(auto);
  options.add(delayLabel);
  options.add(delay);

  add("South", marquee);

  marquee.add("Center", control);
  marquee.add("South", options);
}

public void loadSlides()
  {
    //*******************************************
       Parse the parameters from the HTML File
      *******************************************  
    LoadImages = new MediaTracker(this);    
        
    caption = getParameter("caption");
    imagefile = getParameter("imagefile");
    type    = getParameter("type"); 
    images  = Integer.valueOf(getParameter("images")).intValue();
    slides = new Image[images];
     

    //*******************************************
          Use MediaTracker to load the images
      *******************************************   
    for (int i = 0; i < images; i++) {
      slides[i] = getImage(getDocumentBase(), imagefile + i + "." + type);
      if (i > 0)
	LoadImages.addImage(slides[i], 1);
      else
	LoadImages.addImage(slides[i], 0);
    }                                        

    try {
      LoadImages.waitForID(0);
    } catch (InterruptedException e) {
      System.out.println("Image Loading Failed!");
    }

    showStatus(imagefile + " Images Loaded");
    index = 0;
    repaint();     
    LoadImages.checkID(1,true);

  }

public void start() {
  repaint();
  AutoShow = new Thread(this);
  AutoShow.start();

}

public void stop() {
  index = 0;
  repaint();
  if (AutoShow!= null) 
    AutoShow.stop();
  AutoShow= null;
}

public void run() {
                        
  Thread running = Thread.currentThread();
  while (AutoShow==running) {
    try {
      Thread.sleep(Integer.valueOf(delay.getSelectedItem()).intValue());
    } 
    catch (InterruptedException e) 
      {
	break;
      }
    if (auto.getState() == true) {
      if (LoadImages.checkID(1,true))
	synchronized (this) {
	if (direction==1) {
	  if (index == (images - 1))
	    index = 0;
	  else
	    index++;
	  System.out.print("+");
	  
	}
	else {
	  if (index ==0)
	    index=images - 1;
	  else
	    index--;
	  System.out.print("-");
	}
	repaint();
      }
    }
  }
}

                
                
  //Update is called by repaint()

public void update(Graphics g) {
  try {
    paint(g);
  } catch (ArrayIndexOutOfBoundsException e) {
    if(index < 0)
      index = 0;
    else if (index >= images)
      index = images-1;
    System.out.println("No more Images!");
    slideName.setText("Last # "+Integer.toString(index+1));
  }
}

  //Paint the slide image on the screen
  //And Account for missing images

public void paint(Graphics g) {
  if (LoadImages.isErrorAny()) {
    g.setColor(Color.black);
    g.fillRect(0, 0, getSize().width, getSize().height);
    return;
  }
  if (direction==1) 
    showNext(g);
  else if (direction==-1) 
    showPrevious(g);
  System.out.print(index);
  slideName.setText("# "+Integer.toString(index+1));
}
 
void showPrevious(Graphics g)
  {
    int i;
  
    for ( i=-getSize().width;i<=0;i+=5)
      g.drawImage(slides[index],i , 0, this);
    g.fillRect(0, 0, getSize().width, getSize().height);
 
    g.drawImage(slides[index], 0, 0, this);	
  }
  void showNext(Graphics g){
    int i;
  
    for ( i=0;i<=getSize().width;i+=5)
      g.drawImage(slides[index], getSize().width-i, 0, this);
    g.fillRect(0, 0, getSize().width, getSize().height);
 
    g.drawImage(slides[index], 0, 0, this);
  }
  
public void itemStateChanged(ItemEvent e) 
  {
  }
  
}


class ForwardButtonHandler implements ActionListener 
{
  SlideShow applet;
public ForwardButtonHandler(SlideShow _applet){applet=_applet;}
public void actionPerformed(ActionEvent e)  {
  applet.index++;
  applet.direction=1;
  applet.repaint();
    
}
}
class BackwardButtonHandler implements ActionListener 
{

  SlideShow applet;
public BackwardButtonHandler(SlideShow _applet){applet=_applet;}
public void actionPerformed(ActionEvent e)  {
  applet.direction=-1; 
  applet.index--;  
  applet.repaint();
}
}

  
